/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mozwho dynamic portal.
 *
 * The Initial Developer of the Original Code is Andy Edmonds.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Code partially derived from Chris Waterson's post at:
 * http://groups.google.com/groups?threadm=3897C4E1.2957BC6%40netscape.com
 *  Also derived from bookmarks.js, notably the getParentFolder function
 * http://lxr.mozilla.org/seamonkey/source/xpfe/components/bookmarks/resources/bookmarks.js#1151
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

 

var numFolders = 0;
var docHTML = "";
var crumbNames = new Array(1);
var crumbNodes = new Array(1);
var lastFolderName = "";
var lastFolderNode = "";
var loadInProgress = false;
var count = 0;
var thirdLevCount = 0;
var pathLabel = new Array(1);
var pathNode = new Array(1);
var rootNode;
  
function countFolders(node) {
  dump("\n\n counting folders for " + node.Value );
  if (RDFCUtils.IsContainer(Bookmarks, node)) {
    // It's a folder
  try {
      var name = Bookmarks.GetTarget(node, kNC_Name, true);
  } catch(e) { dump("get target failed \n"); }
    RDFC.Init(Bookmarks, node);
    var contents = RDFC.GetElements();
    while (contents.hasMoreElements()) {
      var child = contents.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
    if(RDFCUtils.IsContainer(Bookmarks, child)) numFolders++;      
  }
 }
 dump(" and found " + numFolders + " \n\n");
}
  
function walk(node, curDepth) {
  var folderTitle = "";
  var child; 
  if(!curDepth) curDepth = 1;
  if (RDFCUtils.IsContainer(Bookmarks, node)) {
   	var name = Bookmarks.GetTarget(node, kNC_Name, true);
   	var description =  Bookmarks.GetTarget(node, kNC_Description,true);
		if(curDepth == 2) {
    	count++;
      lastFolderName = name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
      lastFolderNode = node.Value;
      folderTitle = name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value
      docHTML += "<div class='topfolder' type='folder' container='true' closed='false'";
      docHTML += " ref='" + node.Value + "' title='" +  folderTitle + "' depth='" +(crumbNames.length+1) + "' " ;
      docHTML += " title='" + escape(description) + "' ";
		docHTML += "><b>" + name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value + " "; 
      //(" + RDFC.GetCount() + ")";
      docHTML +="</b> ";
    } else {
      // Write Header For Current Folder
		// GetCount gives bogus numer sometimes.
      if(curDepth == 1) {
        docHTML += "<span id='current' onmousedown='window.location=\"bookmarksfull.html" + window.location.search + "\"'>" ;   
        docHTML += name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value + " (" + RDFC.GetCount() + ")";
        docHTML +=" </span><br/>  "; 
      } else {
        docHTML += "<span class='folder' type='folder'  ";
        // dump("== child of " + lastFolderName + " " + lastFolderNode + "\n");
        docHTML += " parentName='" + lastFolderName + "' parentNode='" + lastFolderNode + "' ";
        docHTML += " ref='" + node.Value + "' title='" +  name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value +  "' depth='" +(crumbNames.length+1) + "' >" ;
         docHTML += name.QueryInterface(Components.interfaces.nsIRDFLiteral).Value + " ";
        //(" + RDFC.GetCount() + ")";  , 
        // Buggy this generates wildy inaccurate counts. Why?
         docHTML +="</span>";
       }
     }
     RDFC.Init(Bookmarks, node);
     var contents = RDFC.GetElements();
     while (contents.hasMoreElements()) {
       child = contents.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
	    if(curDepth < 3) {
	      walk(child,  curDepth+1);  
	    }

     }
   if(curDepth == 2) {
      docHTML += "</div>"
    }      
  }
}
  
function walkMarks(node) {
  if (RDFCUtils.IsContainer(Bookmarks, node)) {
      // It's a folder
    try {
      var name = Bookmarks.GetTarget(node, kNC_Name, true);
    } catch(e) { dump("get target failed \n"); }

      RDFC.Init(Bookmarks, node);
      var contents = RDFC.GetElements();
      while (contents.hasMoreElements()) {
        child = contents.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
        currentLevelMarks(child);
      }     
    }
}
  
function currentLevelMarks(node) {
	var anonID, urlObj, addy;
  if (!RDFCUtils.IsContainer(Bookmarks, node)) {
    // It's a bookmark.
    try {
      docHTML += "<div class='bookmark' type='link' "
			docHTML += " onmouseover='showEdit(this)' ";
			docHTML += " onmouseout='hideEdit(this)' ";
			docHTML += " ref='" + node.Value + "' ";
			docHTML += " container='false' closed='false'>";
			addy = Bookmarks.GetTarget(node, kNC_URL, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
      docHTML += "<a href='" + addy+ "' ";
			anonID = node.Value;
			dump(anonID+"\n");
      try {
				docHTML += " title='"  + Bookmarks.GetTarget(node, kNC_Description, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value + "'"
      } catch(e) {
				// no description.
			}
			docHTML += ">";
      docHTML += Bookmarks.GetTarget(node, kNC_Name, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value ;
     docHTML += "</a>";
		 // Edit/Zoom icons

		 docHTML += "<span style='display:none'><img src='skin/edit.gif' height='14' width='14'  onclick='window.openDialog(\"chrome://communicator/content/bookmarks/bm-props.xul\",\"\",\"centerscreen,chrome,dependent,resizable=no\", \""+ anonID+"\");return false;event.stopPropagation(); '   ";
		 docHTML += "  border='0'/>";
		 docHTML += "<img src='skin/zoom.gif' height='14' width='14'  onclick='getInfo(this.parentNode.parentNode);return false;event.stopPropagation(); '   ";
		 docHTML += "  border='0'/>";
		 docHTML += "<img src='skin/expand.gif' height='14' width='14'  onclick='expand(this.parentNode.parentNode);return false;event.stopPropagation(); '   ";
		 docHTML += "  border='0'/>";

		 docHTML +="</span></div>";
		 dump("ID is " + anonID + "\n");
		 
   } catch(e) {
	 	 dump("err " + e + "\n");
	 }  
  }

}

function getInfo(addyNode) {
	dump(addyNode.nodeName);
	if(!addyNode.hasAttribute("lookup")) {
	addy = addyNode.childNodes.item(0).getAttribute("href");
	var freshness;
	docHTML = '';
	var maxwidth = 80;
	var epochDay = 86400000;
	var refTime = new Date().getTime() - 100000000000;
	var nowTime = new Date().getTime();
	var scale = (nowTime - refTime) / refTime * 80; //maxwidth;
		searchURI = "";
  	searchURI += "&match=http://home.netscape.com/NC-rdf#URL";
   	searchURI += "&method=is"; // or contains
    searchURI += "&text=" + addy;
		urlObj = urlInHistory(searchURI)[0];

		if(!isNaN(urlObj.visitcount)) docHTML +=  + urlObj.visitcount + "<br/>";
		if(urlObj.lastvisit && urlObj.visitcount) {
		dump("Now: " + nowTime + "\nLVt: " + lastvisit + "\n");
		freshness = (nowTime - (urlObj.lastvisit/1000))/epochDay;
		dump("Visit count log " + Math.log(visitcount) + "\n");
		logGifSize = Math.log(freshness) * 10;
		logVisitSize = Math.log(visitcount) * 10;
		dump("Delta is " + (urlObj.lastvisit -urlObj.firstvisit) + "\n");
		dump("Fresh is " + freshness + " scale " + scale + "\n");
		/*docHTML += "fresh:<img src='skin/dot_blue.gif' vspace='2' height='4' align='left' ";
		docHTML += "width='" + (freshness*10) + "' title='";
		docHTML += urlObj.lastvisit + " " + urlObj.firstvisit + "'><br clear='left'>";
		*/
		docHTML += "<img src='skin/dot_maroon.gif' vspace='2' height='4' align='left' ";
		
		docHTML += "width='" + logVisitSize + "' title='";
		docHTML += "Total visits " + urlObj.visitcount + "'><br clear='left'>";
		
		docHTML += "<img src='skin/dot_orange.gif' vspace='0' height='4' align='left' ";
		docHTML += "width='" + logGifSize + "' title='";
		docHTML += " last vist " + freshness + "'><br clear='left'>";
		
	}
	addyNode.setAttribute("lookup", "true");
	addyNode.childNodes.item(1).innerHTML += docHTML;
	}
}


function expand(addyNode) {
	dump(addyNode.nodeName);
	if(!addyNode.hasAttribute("expand")) {
	addy = addyNode.childNodes.item(0).getAttribute("href");
	docHTML = '<br/><span style="font-size:.8em;">';	
	// Move this to subfunc
	// recognize ~ and top level directs?
	// google query
	var root = addy.replace("http://", "");
	root = root.substr(0,root.indexOf("/"));
	dump("root is " + root + "\n");
	searchURI = "";
  searchURI += "&match=http://home.netscape.com/NC-rdf#URL";
  searchURI += "&method=contains"; // or contains
  searchURI += "&text=" + "http://" +root;
	urlObj = urlInHistory(searchURI)

	for(var i=0;i<urlObj.length;i++) {
		if(urlObj[i].markurl != addy) docHTML += "&nbsp;&nbsp;<a href='" + urlObj[i].markurl + "'>" + urlObj[i].name + "</a><br/>";
		
	}
	docHTML += "</span>";
	addyNode.setAttribute("expand", "true");
	addyNode.childNodes.item(1).innerHTML += docHTML;
	}
}

function buildCrumb(nodeID) {
  mystr = "";
	var title;
  dump("\n\n --- CRUMBS --- " +  pathNode + " " + pathLabel + " crumbs \n\n");
	var newParentID = nodeID; // Storage for current RDF ID
	var node; // storage for RDF object
	
  while(newParentID != "NC:BookmarkRoot" && newParentID != "NC:BookmarksTopRoot" && newParentID != "NC:BookmarksRoot" ) {
		node =  RDF.GetResource(nodeID);
		arcCursor = Bookmarks.ArcLabelsIn(node); 
		newParentID =getParentFolder( node, arcCursor);
		dump("Got parent " + newParentID + "\n");
		node = RDF.GetResource(newParentID);
		title = Bookmarks.GetTarget(node, kNC_Name, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value ;
		mystr= "<span type='breadcrumb' ref='" + newParentID + "' class='crumb' depth ='1'>" + title + "</span>  <span class='crumbdivider'>>></span> " + mystr; 
		nodeID = newParentID;
	}  
  document.getElementById("breadcrumb").innerHTML = mystr;
}


function mozwhoInit() {
  dump("\n\n\n|INIT mozwho|\n\n");
  dump("URL: " + location.search + "\n\n");
  // Are we at the root? 
  // Or do we have a target string?
  if(location.search != "") {
    dump("parsing url params " + typeof(parseQueryString("labels")) + "\n")
    var paths = parseQueryString("labels");
    pathLabel = paths.split(",");
    var nodes = parseQueryString("nodes");
    pathNode = nodes.split(",");
   // dump("---label is " + pathLabel + " " + pathLabel.length +" \n---and path is " + pathNode + " " + pathNode.length + "\n");
    node = pathNode[pathNode.length-1];
    buildCrumb(node);
    document.title ="mozwho:  " + paths;
  } else {
    dump("Resetting Path to Root \n")
    path="Home";
    node="NC:BookmarksRoot";;
    pathNode[0] = "NC:BookmarksRoot";
    pathLabel[0] = "Home"; 
  }
  dump("Initing node " + node + "\n");
  node =  RDF.GetResource(node);
	// Need this var for the arc functions
	// rootDS = RDF.GetDataSource("rdf:bookmarks")
  countFolders(node);
  // Write FOlders
  walk(node);
  document.getElementById('folders').innerHTML = docHTML;
  //addListeners();
  docHTML="";
  // Write bookmarks
  walkMarks(node);
  document.getElementById('marks').innerHTML = docHTML;
}

function getParentFolder(thisResource,arcCursor) {
  while(arcCursor.hasMoreElements()) {
		thisArc = arcCursor.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
		if (RDFCUtils.IsOrdinalProperty(thisArc)) {
			//dump("got container arc  " + thisArc.Value + "\n");
			return   Bookmarks.GetSources(thisArc, thisResource, true).getNext().QueryInterface(kRDFRSCIID).Value;
		}
	}
}

function urlInHistory(searchURI) {
  var searchURI = "find:datasource=rdf:history" + searchURI;
	var contents, child, name, description, markurl,rdfid;
	var returnObj = new Array(); //Object();
	var offset;
	var resultMarkDS = RDF.GetDataSource("rdf:localsearch");
  dump("Processing " + searchURI + "\n");
  var node = RDF.GetResource(searchURI);    
	resultMarks= resultMarkDS.GetTargets(node, kNC_child, true);
  while (resultMarks.hasMoreElements()) {
  	child = resultMarks.getNext().QueryInterface(Components.interfaces.nsIRDFResource);
  	dump("Looping over " + child.Value + "\n");
	  offset = returnObj.length;
		returnObj[offset] = new Object();
		returnObj[offset].rdfid = child.Value;
		dump("HS is " + History + "\n");
	  try{ 
		  returnObj[offset].name = History.GetTarget(child, kNC_Name, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
  	  returnObj[offset].markurl =  History.GetTarget(child, kNC_URL, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value;

			visitcount = History.GetTarget(child, kNC_VisitCount, true).QueryInterface(Components.interfaces.nsIRDFInt).Value;
			returnObj[offset].visitcount=visitcount;
			dump("visit count is " + visitcount + "\n");
			firstvisit = History.GetTarget(child, kNC_FirstVisitDate, true).QueryInterface(Components.interfaces.nsIRDFDate).Value; 
			returnObj[offset].firstvisit=firstvisit;

			lastvisit = History.GetTarget(child, kNC_Date, true).QueryInterface(Components.interfaces.nsIRDFDate).Value; 
			returnObj[offset].lastvisit=lastvisit;

	dump(" "+ visitcount + " from " + firstvisit + " to " + lastvisit + "\n with" + searchURI + "\n\n");
		} catch(err) {
			dump("ERR: " + err + "\n");
		}
	}

	return returnObj;
}

